/*
 * Copyright(C) 2002-2011  
 *
 *    , 
 *    .
 *
 *        ,
 * ,    ,
 *     ,
 * ,      
 *     
 *      .
 */

#include "fat12prj.h"
#include <unistd.h>

/*++++
 * Lock function
 ++++*/
TSupErr fat12_lock( 
    TSupSysContext *context, 
    TSupSysInfo *info )
{
  TFat12Context *ctx = (TFat12Context*)context;

  SUPSYS_PRE_INFO( info, TReaderInfoLock );
  SUPSYS_PRE_CONTEXT( context, TFat12Context );

  if (!ctx->n_lock)
  {
    if(support_mutex_lock(ctx->lock))
	return SUP_ERR_CANCEL;
    /* n_lock -  .
     * ,  - ctx    ,   n_lock    ,
     *   lock - .
     */
  }
  ctx->n_lock++;
  return SUP_ERR_NO;
}

/*++++
 * Unlock function
 ++++*/
TSupErr fat12_unlock( 
    TSupSysContext *context, 
    TSupSysInfo *info )
{
  TFat12Context *ctx = (TFat12Context*)context;

  SUPSYS_PRE_INFO( info, TReaderInfoLock );
  SUPSYS_PRE_CONTEXT( context, TFat12Context );
  
  if (!(--ctx->n_lock))
  {
    support_mutex_unlock(ctx->lock);
  }

  return SUP_ERR_NO;
}
